set infile record.dat

proc get_int {fp} {
	if ![binary scan [read $fp 4] i var] {error "ERROR:get_int"}
	return $var
}

proc get_short {fp} {
	if ![binary scan [read $fp 2] s var] {error "ERROR:get_short"}
	return $var
}

proc get_uchar {fp} {
	if ![binary scan [read $fp 1] c var] {error "ERROR:get_uchar"}
	return [expr $var & 0xff]
}

proc get_string {fp} {
	set len [get_uchar $fp]
	if {$len == 0} return {}
	if {$len >= 255} {
		set len [get_short $fp]
	}
	return [encoding convertfrom cp932 [read $fp $len]]
}

proc get_week {fp} {
	if ![binary scan [read $fp 4] b7 var] error
	set wlist {Sun Mon Tue Wed Thu Fri Sat}
	set ret [list]
	foreach w $wlist f [split $var {}] {
		if $f {lappend ret $w}
    }
	return $ret
}

proc skip {fp num} {
	read $fp $num
}

# \񐔂̎擾
proc get_record_number {fp} {
	seek $fp 4 start
	return [get_int $fp]
}

# e\f[^̎擾
proc get_record {fp} {
	array set r {}
	set hnum [get_int $fp]
	if {$hnum != 2662} {error "bad header $hnum"}
	set r(foCX)       [get_string $fp]
	set r(RvX)     [get_string $fp]
	set r(}`vNX) [get_string $fp]
	set r(Rg)       [get_string $fp]
	set r(fBNg)   [get_string $fp]
	set r(t@C)     [get_string $fp]
	set r(K)       [get_int $fp]
	set r(Jn)       [get_int $fp]
	set r(I)       [get_int $fp]
	skip $fp 4 ;# XXX:sf[^
	set r(HDXsAbv) [get_int $fp]
	set r(Nj)       [get_week $fp]
	set r(`l)     [get_int $fp]
	set r(I[fBI)     [get_int $fp] ;# FIXME:Kv̂œǂݔ΂
	set r()           [get_int $fp]
	return [array get r]
}

set fp [open $infile r]
fconfigure $fp -translation binary

# \񐔂̎擾
set recordnum [get_record_number $fp]
if {$recordnum == 0} {
	puts "\񂪂܂"
	exit 0
}
skip $fp 20

# e\f[^̓ǂݍ
set rlist [list]
for {set i 0} {$i < $recordnum} {incr i} {
	lappend rlist [get_record $fp]
	catch {skip $fp 2}
}

close $fp
exit 0
